import es, path, zipfile, urllib, base64

info = es.AddonInfo()
info.version = '2.0alpha7'
info.author = 'Ojii'


neededkeys = ['username','password','description','esversion','summary','install','loadname','version','releasenotes','fullname']
allkeys = ['username','password','description','esversion','summary','install','loadname','version','releasenotes','fullname','forumurl','publicvariable','featurlistbasename','videourl','ready','status']
gp = path.path(str(es.ServerVar('eventscripts_gamedir')))

def load():
    es.regcmd('build','builder/build') # build basename
    es.regcmd('builderhelp','builder/help') # help :D
    es.regcmd('addinfo','builder/addinfo') # addinfo basename var value
    es.regcmd('upload','builder/upload') # upload basename
    
def help():
    print 'BUILDER: No help so far!'
    
def addinfo():
    if es.getargc() != 4:
        print 'BUILDER: Invalid syntax! Use: addinfo <basename> <variable> <value>'
    name = es.getargv(1)
    var = es.getargv(2)
    value = es.getargv(3)
    ap = path.path(es.getAddonPath(es.getargv(1)))
    if not ap.isdir():
        print 'BUILDER: Couldn\'t find addon folder!'
        return
    if not var in allkeys:
        print 'BUILDER: Invalid variable!'
        print 'BUILDER: Possible variables:'
        print 'BUILDER: %s' % ','.join(allkeys)
    uf = ap.joinpath('%s.upload' % name)
    L = uf.lines(retain=False)
    done = False
    x = 0
    for line in L:
        if line.startswith(var):
            del L[x]
            L.insert(x,'%s %s' % (var,value))
            done = True
            break
        x += 1
    if not done:
        L.append('%s %s' % (var,value))
    tobedeleted = []
    for line in L:
        ok = False
        for key in allkeys:
            if line.startswith(key):
                ok = True
        if not ok:
            tobedeleted.append(line)
    for line in tobedeleted:
        L.remove(line)
    uf.write_lines(L)
    print 'BUILDER: Added info: %s %s' % (var,value)

def upload():
    if es.getargc() != 2:
        print 'BUILDER: Invalid syntax! Use: upload <basename>'
        return
    ap = path.path(es.getAddonPath(es.getargv(1)))
    if not ap.isdir():
        print 'BUILDER: Couldn\'t find addon folder!'
        return
    name = es.getargv(1)
    uf = ap.joinpath('%s.upload' % name)
    if not uf.isfile():
        print 'BUILDER: Uploadfile not found!'
        print 'BUILDER: Use addinfo <basename> <var> <value> to add info or add manuall'
        return
    L = uf.lines(retain=False)
    ud = {}
    for line in L:
        key,val = line.split(' ',1)
        ud[key] = val
    for key in neededkeys:
        if not ud.has_key(key):
            print 'BUILDER: Not enough information in upload file!'
            print 'BUILDER: Use addinfo <basename> <var> <value> to add info or add manuall'
            return
    zf = ap.joinpath('%s_%s.zip' % (name,ud['version'].replace(':','_')))
    if not zf.isfile():
        print 'BUILDER: ZIP Archive not found!'
        print 'BUILDER: Make sure you built the addon before you try to upload!'
        print 'BUILDER: Use build <basename> to build it'
        return
    ### UPLOADER ###
    ESAMURL = 'http://testadd.eventscripts.com/sdk/upload'
    print 'BUILDER: Starting upload...'
    print 'BUILDER: Depending on your filesize this might take a while. Grab a beer!'
    raw_params = [
        ('username',ud['username']),
        ('password',ud['password']),
        ('basename',name),
        ('filename',str(zf.basename())),
        ('filecontent',base64.b64encode(zf.bytes())),
        ('filesize',zf.getsize()),
        ('filetype',str(zf.ext)[1:]),
        ('desc',ud['description'].replace('\\n','''
''')),
        ('esver',ud['esversion']),
        ('summ',ud['summary']),
        ('install',ud['install'].replace('\\n','''
''')),
        ('path',ud['loadname']),
        ('ver',ud['version']),
        ('notez',ud['releasenotes'].replace('\\n','''
''')),
        ('name',ud['fullname']),
        ('forum',ud['forumurl'] if ud.has_key('forumurl') else ''),
        ('var',ud['publicvariable'] if ud.has_key('publicvariable') else ''),
        ('florg',ud['featurlistbasename'] if ud.has_key('featurlistbasename') else ''),
        ('video',ud['videourl'] if ud.has_key('videourl') else ''),
        ('ready',ud['ready'] if ud.has_key('ready') else 'True'),
        ('status',ud['status'] if ud.has_key('status') else 'Normal'),
    ]
    params = urllib.urlencode(raw_params)
    upload = urllib.urlopen(ESAMURL,params)
    response = upload.read()
    print 'BUILDER: Upload finished!'
    print 'BUILDER: %s' % response
        
def extractDownloadable(line):
    if 'es.stringable' in line: # 2.x
        start = line.find('es.stringtable')
        end = line.find(')',start)
        tline = line[stp+14:end] # line between es.stringtable( and )
        table,filepath = tline.split(',')
        table = table.strip().strip('"').strip("'").strip()
        if table == 'downloadables':
            filepath = filepath.strip().strip('"').strip("'").strip()
            download = gp.joinpath(filepath[1:]) if filepath[0] in ('\\','/') else gp.joinpath(filepath)
            if download.isfile():
                return download
    elif 'es_stringtable' in line: # 1.x
        command, table, filepath = line.split(' ',2)
        if table == 'downloadables':
            filepath = filepath.strip().strip('"').strip("'").strip()
            download = gp.joinpath(filepath[1:]) if filepath[0] in ('\\','/') else gp.joinpath(filepath)
            if download.isfile():
                return download
    elif 'downloadable' in line: # 1.x corelib
        command, filepath = line.split(' ',1)
        filepath = filepath.strip().strip('"').strip("'").strip()
        download = gp.joinpath(filepath[1:]) if filepath[0] in ('\\','/') else gp.joinpath(filepath)
        if download.isfile():
            return download
    return False
    
def build():
    print ''
    if es.getargc() != 2:
        print 'BUILDER: Invalid syntax! Use: build <basename>'
        return
    ap = path.path(es.getAddonPath(es.getargv(1)))
    if not ap.isdir():
        print 'BUILDER: Couldn\'t find addon: %s' % es.getargv(1)
        return
    name = es.getargv(1)
    print 'BUILDER: Scanning main file for version info and downloadables'
    version = '1'
    main = ap.joinpath('%s.py' % name) if ap.joinpath('%s.py' % name).isfile() else ap.joinpath('es_%s.txt' % name)
    if not main.isfile():
        print 'BUILDER: Couldn\'t find main script file!'
        return
    uf = ap.joinpath('%s.upload' % name)
    L = []
    if uf.isfile():
        L = uf.lines(retain=False)
    downloadables = []
    done = []
    for line in main.lines(retain=False):
        if line.strip().startswith('info.version'):
            version = line.split('=')[1].strip().strip("'").strip('"')
            if len(L) != 0:
                x = 0
                for line in L:
                    if line.startswith('version'):
                        del L[x]
                        L.insert(x,'version %s' % version)
                        break
                    x += 1
            else:
                L.append('version %s' % version)
            print 'BUILDER: Version found: %s' % version
        if 'stringtable' in line and 'downloadables' in line:
            tmp = extractDownloadable(line)
            if tmp:
                downloadables.append(tmp)
        elif 'downloadable' in line:
            tmp = extractDownloadable(line)
            if tmp:
                downloadables.append(tmp)
    print 'BUILDER: Writing zipfile'
    bf = ap.joinpath('%s.build' % name)
    extensions = ['py','txt','ini','cfg']
    strict = False
    exclude = []
    if bf.isfile():
        bflines = bf.lines(retain=False)
        firstline = bflines[0] if len(bflines) > 0 else ''
        secondline = bflines[1] if len(bflines) > 1 else ''
        if firstline.startswith('__extensions__'):
            extensions = firstline[12:].split(',')
        elif firstline == '__strict__':
            strict = True
        elif secondline == '__strict__':
            strict = True
        elif firstline == '__exclude__' or secondline == '__exclude__':
            for line in bflines:
                if not line.startswith('__'):
                    f = gp.joinpath(line[1:] if line[0] in ('/','\\') else line)
                    if f.isfile():
                        exclude.append(f.normpath())
                    elif f.isdir():
                        for ff in f.walkfiles():
                            exclude.append(ff.normpath())
    zf = ap.joinpath('%s_%s.zip' % (name,version.replace(':','_')))
    zip = zipfile.ZipFile(zf,'w')
    if not strict:
        for ext in extensions:
            ex = '.%s' % ext.strip()
            for f in ap.walkfiles('*%s' % ex):
                if not exclude or f.normpath()  not in exclude:
                    print 'BUILDER: Adding %s' % f.encode('ascii')
                    zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
                    done.append(f)
        for downloadable in downloadables:
            if not exclude or downloadable.normpath() not in exclude:
                print 'BUILDER: Adding %s' % downloadable.encode('ascii')
                zip.write(downloadable.encode('ascii'),gp.relpathto(downloadable).encode('ascii'))
                done.append(downloadable)
        cfg = gp.joinpath('cfg/%s.cfg' % name)
        if cfg.isfile():
            if not exclude or cfg.normpath()  not in exclude:
                print 'BUILDER: Adding %s' % f.encode('ascii')
                zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
                done.append(f)
    if bf.isfile() and not exclude:        
        for line in bflines:
            if not line.startswith('__'):
                f = gp.joinpath(line[1:] if line[0] in ('/','\\') else line)
                if f not in done and f.isfile():
                    print 'BUILDER: Adding %s' % f.encode('ascii')
                    zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
                    done.append(f)
                elif f.isdir():
                    for ff in f.walkfiles():
                        if not ff in done:
                            print 'BUILDER: Adding %s' % ff.encode('ascii')
                            zip.write(ff.encode('ascii'),gp.relpathto(ff).encode('ascii'))
                            done.append(ff)
    zip.close()
    uf.write_lines(L)
    print 'BUILDER: Done'
    print ''